﻿#target photoshop

/* Ultimate phone tablet screenshot exporter Script by Hannes Delbeke 22/05/2013
 *  based on work ofTomek Cejner (tomek (at) japko dot info) (support of nested layer groups,  and exports single layers in addition to groups)
 *  based on work of Damien van Holten: http://www.damienvanholten.com/blog/export-groups-to-files-photoshop/
 */


function main(){

    app.preferences.rulerUnits = Units.PIXELS ; 
    app.preferences.typeUnits = TypeUnits.PIXELS ;   
    
    if(!documents.length) return;
    var doc = activeDocument;
    var oldPath = activeDocument.path;
     
    var outFolder = new Folder(oldPath + "/out");
    if (!outFolder.exists) 
    {
        outFolder.create();
    }

    var h = 0;
    var w = 0;

    var wRetina = 2048;
    var hRetina = 1536;
    var outFolderRetina= new Folder(outFolder + "/IPad Retina");
    if (!outFolderRetina.exists) 
    {
        outFolderRetina.create();
    }

    var wIPad = 1024;
    var hIPad = 768;
    var outFolderIPad= new Folder(outFolder + "/IPad");
    if (!outFolderIPad.exists) 
    {
        outFolderIPad.create();
    }

    var wIPhone4 = 960;
    var hIPhone4 = 640;
    var outFolderIPhone4= new Folder(outFolder + "/IPhone4");
    if (!outFolderIPhone4.exists) 
    {
        outFolderIPhone4.create();
    }

    var wIPhone5 = 1136;
    var hIPhone5 = 640;
    var outFolderIPhone5= new Folder(outFolder + "/IPhone5");
    if (!outFolderIPhone5.exists) 
    {
        outFolderIPhone5.create();
    }

    var wAndroid1 = 1280;
    var hAndroid1 = 800;
    var wAndroid2 = 1280;
    var hAndroid2 = 720;
    var wAndroid3 = 2048;
    var hAndroid3 = 1152;
    var outFolderAndroid= new Folder(outFolder + "/Android");
    if (!outFolderAndroid.exists) 
    {
        outFolderAndroid.create();
    }

    //to add a new device copy this  and replace NAME with the device name and FOLDERNAME with the map/folder name
    /* 
    var wNAME = 1000;
    var hNAME = 1000;
    var outFOLDERNAME= new Folder ( outFolder + "/FOLDERNAME");
    if ( outFOLDERNAME.exists) 
    {
        outFOLDERNAME.create();
    }
    */

    scanLayerSets(doc);
     
    function scanLayerSets(el) 
    {
        // find layer groups
        for(var a=0;a<el.layerSets.length;a++)
        {
            var groupScreen = el.layerSets[a] ;
            groupname = groupScreen.name; //check name for every layer
            
            if (groupname.substr(-4) == ".jpg")  //if name ends in jpg 
            {
                 //alert("jpg");
                   
                //find txt group
                for(var b=0;b< groupScreen.layerSets.length;b++) //layersets are groups
                {
                    var txtgroup = groupScreen.layerSets[b] ;
                // alert("jpg"+txtgroup);
                    var txtname = txtgroup.name;
                    if (txtname == "txt")  //if name is txt
                    {
                        var LanguageLayer;
                        
                           /// alert("txt" + groupScreen.artLayers.length );
                        for(var c=0;c<txtgroup.artLayers.length;c++) //check all layers in the txt file
                        {
                            LanguageLayer = txtgroup.artLayers[c] ;
                            LanguageLayer.visible = false;
                         //   alert("txt2");
                        }
                        for( var d=0;d<txtgroup.artLayers.length;d++) //check all layers in the txt file
                        {
                            LanguageLayer = txtgroup.artLayers[d] ;
                            LanguageLayer.visible = true; //put  1 txt layer on visible
                            saveLayer(groupScreen,LanguageLayer,oldPath,true);//save the file
                            LanguageLayer.visible = false; //put it back invisible for next layer
                           //// alert("txt3");
                        }
                    //uncomment next lien to see a pop up when finished ( 1 popup each screenshot )
                  //  alert("exporting done, " +txtgroup.artLayers.length+ " files exported")
                    }
                }
            }
        }
    }
     
    function saveLayer(layer, lname, path, shouldMerge) 
    {
        //first layer isthe group/screenshot
        //second layer is the current language text
        //var 3 is the current path
        //shouldmerge is true   (if its a group)
         activeDocument.activeLayer = layer;
         var screenName = "temp" ;
        //====================       
        //RETINA
        //====================       
         var namedevice = "Retina" ;
         dupLayers();
        w = wRetina ;
        h = hRetina ;
        activeDocument.resizeCanvas( w , h ,AnchorPosition.MIDDLECENTER);
        screenName = layer.name ;
        screenName = screenName.substring(0,screenName.length-4 );
        var exportName = "/" + lname.name + "_"+ screenName + "_"+ namedevice + "_"+  w  + "x"+ h  + ".jpg";
                          
        if (shouldMerge === undefined || shouldMerge === true) 
        {
            activeDocument.mergeVisibleLayers();
        }
        activeDocument.trim(TrimType.TRANSPARENT,true,true,true,true);
        var saveFile= File(outFolderRetina +exportName);
        SaveForWeb(saveFile,80); //save as jpg quality 80
        //====================       
        //IPAD
        //====================       
        var namedevice = "IPad" ;
        w = wIPad ;
        h = hIPad ;
        activeDocument.resizeImage(w,h);
        screenName = layer.name ;
        screenName = screenName.substring(0,screenName.length-4 );
        var exportName = "/" + lname.name + "_"+ screenName + "_"+ namedevice + "_"+  w  + "x"+ h  + ".jpg";
        var saveFile= File(outFolderIPad+exportName);
        SaveForWeb(saveFile,80); //save as jpg quality 80
        app.activeDocument.close(SaveOptions.DONOTSAVECHANGES);
          
        
        //====================       
        //Googleplay  = Android 3
        //====================   
        activeDocument.activeLayer = layer;
        var namedevice = "Android" ;
        dupLayers();
        w = wAndroid3 ;
        h = hAndroid3 ;
        activeDocument.resizeImage(w,h);
        screenName = layer.name ;
        screenName = screenName.substring(0,screenName.length-4 );
        var exportName = "/" + lname.name + "_"+ screenName + "_"+ namedevice + "_"+  w  + "x"+ h + "_11inch" + ".jpg";               
        if (shouldMerge === undefined || shouldMerge === true) 
        {
            activeDocument.mergeVisibleLayers();
        }
        activeDocument.trim(TrimType.TRANSPARENT,true,true,true,true);
        var saveFile= File( outFolderAndroid +exportName);
        SaveForWeb(saveFile,80); //save as jpg quality 80
        app.activeDocument.close(SaveOptions.DONOTSAVECHANGES);
        
        //====================       
        //NEWDEVICE
        //====================   
        //replace NAME with the device name and FOLDERNAME with the folder/map name
        /*
        activeDocument.activeLayer = layer;
        var namedevice = "NAME" ;
        dupLayers();
        w = wNAME ;                                                                                       //REPLACE HERE <===========
        h = hNAME ;                                                                                         //REPLACE HERE <===========
        activeDocument.resizeImage(w,h);
        screenName = layer.name ;
        screenName = screenName.substring(0,screenName.length-4 );
        var exportName = "/" + lname.name + "_"+ screenName + "_"+ namedevice + "_"+  w  + "x"+ h + ".jpg";               
        if (shouldMerge === undefined || shouldMerge === true) 
        {
            activeDocument.mergeVisibleLayers();
        }
        activeDocument.trim(TrimType.TRANSPARENT,true,true,true,true);
        var saveFile= File( outFOLDERNAME +exportName);                             //REPLACE HERE <===========
        SaveForWeb(saveFile,80); //save as jpg quality 80
        app.activeDocument.close(SaveOptions.DONOTSAVECHANGES);
        */
    
        //====================       
        //Googleplay  = Andrid 
        //====================   
        activeDocument.activeLayer = layer;
        var namedevice = "Android" ;
        dupLayers();
        w = wAndroid2 ;
        h = hAndroid2 ;
        activeDocument.resizeImage(w,h);
        screenName = layer.name ;
        screenName = screenName.substring(0,screenName.length-4 );
        var exportName = "/" + lname.name + "_"+ screenName + "_"+ namedevice + "_"+  w  + "x"+ h + "_11inch" + ".jpg";               
        if (shouldMerge === undefined || shouldMerge === true) 
        {
            activeDocument.mergeVisibleLayers();
        }
        activeDocument.trim(TrimType.TRANSPARENT,true,true,true,true);
        var saveFile= File( outFolderAndroid +exportName);
        SaveForWeb(saveFile,80); //save as jpg quality 80
        
        
        //====================       
        //IPhone5
        //====================  
        var namedevice = "IPhone5" ;
        w = wIPhone5 ;
        h = hIPhone5 ; 
        activeDocument.resizeImage( w , h );
        screenName = layer.name ;
        screenName = screenName.substring(0,screenName.length-4 );
        var exportName = "/" + lname.name + "_"+ screenName + "_"+ namedevice + "_"+  w  + "x"+ h  + ".jpg";
        var saveFile= File( outFolderIPhone5 +exportName);
        SaveForWeb(saveFile,80); //save as jpg quality 80
        app.activeDocument.close(SaveOptions.DONOTSAVECHANGES);
       
        //====================       
        //Googleplay 1
        //====================   
        activeDocument.activeLayer = layer;
        var namedevice = "Android" ;
        dupLayers();
        w = 1.0*wRetina*wAndroid1/hRetina ;
        h = hAndroid1 ;
       activeDocument.resizeImage(null,h);
      //  activeDocument.height = h ;
        w = wAndroid1 ;
        activeDocument.resizeCanvas( w , h ,AnchorPosition.MIDDLECENTER);
        screenName = layer.name ;
        screenName = screenName.substring(0,screenName.length-4 );
        var exportName = "/" + lname.name + "_"+ screenName + "_"+ namedevice + "_"+  w  + "x"+ h + "_7inch" + ".jpg";             
        if (shouldMerge === undefined || shouldMerge === true) 
        {
            activeDocument.mergeVisibleLayers();
        }
        activeDocument.trim(TrimType.TRANSPARENT,true,true,true,true);
        var saveFile= File( outFolderAndroid +exportName);
        SaveForWeb(saveFile,80); //save as jpg quality 80
        
        //====================       
        //IPhone4
        //====================   
        var namedevice = "IPhone4" ;
        w = 1.0 * w * wIPhone4 / h ;
        h = hIPhone4 ;
       activeDocument.resizeImage(null,h);
        w = wIPhone4 ;
        activeDocument.resizeCanvas( w , h ,AnchorPosition.MIDDLECENTER);
        screenName = layer.name ;
        screenName = screenName.substring(0,screenName.length-4 );
        var exportName = "/" + lname.name + "_"+ screenName + "_"+ namedevice + "_"+  w  + "x"+ h  + ".jpg";             
        var saveFile= File( outFolderIPhone4 +exportName);
        SaveForWeb(saveFile,80); //save as jpg quality 80
        app.activeDocument.close(SaveOptions.DONOTSAVECHANGES);
        
        //add more devides here
     
    }
};
 
main();
 
function dupLayers() { 
    var desc143 = new ActionDescriptor();
        var ref73 = new ActionReference();
        ref73.putClass( charIDToTypeID('Dcmn') );
    desc143.putReference( charIDToTypeID('null'), ref73 );
    desc143.putString( charIDToTypeID('Nm  '), activeDocument.activeLayer.name );
        var ref74 = new ActionReference();
        ref74.putEnumerated( charIDToTypeID('Lyr '), charIDToTypeID('Ordn'), charIDToTypeID('Trgt') );
    desc143.putReference( charIDToTypeID('Usng'), ref74 );
    executeAction( charIDToTypeID('Mk  '), desc143, DialogModes.NO );
};
 function SaveForWeb(saveFile,jpegQuality) {
    var sfwOptions = new ExportOptionsSaveForWeb(); 
   sfwOptions.format = SaveDocumentType.JPEG; 
   sfwOptions.includeProfile = false; 
   sfwOptions.interlaced = 0; 
   sfwOptions.optimized = true; 
   sfwOptions.quality = jpegQuality; //0-100 
    activeDocument.exportDocument(saveFile, ExportType.SAVEFORWEB, sfwOptions);
}
function SavePNG(saveFile){
    var pngOpts = new ExportOptionsSaveForWeb; 
    pngOpts.format = SaveDocumentType.PNG
    pngOpts.PNG8 = false; 
    pngOpts.transparency = true; 
    pngOpts.interlaced = false; 
    pngOpts.quality = 100;
    activeDocument.exportDocument(new File(saveFile),ExportType.SAVEFORWEB,pngOpts); 
}